#import "@preview/fletcher:0.5.3" as fletcher: diagram, node, edge
#set page(width: auto, height: auto, margin: 5mm)

#set table(
	align: (x, y) => (
		if y == 0 { center }
		else { left }
	)
)

#diagram({
	node((1,2),
		table(
			columns: (auto),
			table.header([*ConcreteCreatorA*]),
			[...], [`+ createProduct(): Product`]
		),
		name: <a>, shape: rect
	)

	node((2,2),
		table(
			columns: (auto),
			table.header([*ConcreteCreatorB*]),
			[...], [`+ createProduct(): Product`]
		),
		name: <b>, shape: rect
	)
	
	node((1.5,2), stroke: red, [`4`])

	node((1.5,1),
		table(
			columns: (auto),
			table.header([*Creator*]),
			[...], [#text[`+ SomeOperation()`] \
				#text[`+ createProduct(): Product`]]
		),
		name: <c>
	)

	edge(<a.north>, ((), "|-", (<a.north>, 50%, <c.south>)),
		((), "-|", <c>), <c>, "-|>")
	edge(<b.north>, ((), "|-", (<b.north>, 50%, <c.south>)),
		((), "-|", <c>), <c>)
	
	node((3,1),
		table(
			columns: (auto),
			table.header([$<<"interface">>$ \ *Product*]),
			[`+ doStuff()`]
		),
		name: <p>
	)
	node(<p.north-east>, stroke: red, [`1`])

	edge(<c>, "..|>", <p>)

	node((.5,.5), stroke: black, [```Product p = createProduct()
		p.doStuff()```], fill: silver, name: <c1>)
	
	edge((<c.north-west>, 75%, <c.south-west>), "..", <c1.south>,
		corner: right)
	
	node((1,3), [`return new ConcreteProductA()`],
		stroke: black, fill: silver, name: <a1>)
	edge(<a>, "..", <a1>)
})
